/*
 * 2004  Abacus Research AG , St. Gallen , Switzerland . All rights reserved.
 * Terms of Use under The GNU GENERAL PUBLIC LICENSE Version 2
 *
 * THIS SOFTWARE IS PROVIDED BY ABACUS RESEARCH AG ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR 
 * NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL ABACUS RESEARCH AG BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

/** Creator:
 * 20.04.2005 10:48:43 Misteli
 *
 * Maintainer:
 * 20.04.2005 10:48:43 Misteli
 *
 * Last Modification:
 * $Id: MyAbstractTextEditor.java,v 1.1 2005/09/06 15:59:20 sbooth Exp $
 *
 * Copyright (c) 2003 ABACUS Research AG, All Rights Reserved
 */

package ch.abacus.designcockpit.ide.propertyinspector;


import ch.abacus.lib.ui.propertyinspector.display.editor.BaseEditor;
import ch.abacus.lib.ui.propertyinspector.display.editor.EditorValueAccessor;
import ch.abacus.lib.ui.propertyinspector.display.editor.EditorDelegate;

import javax.swing.*;

public abstract class MyAbstractTextEditor extends BaseEditor implements EditorValueAccessor {

    public abstract JTextField getEditor();

    public MyAbstractTextEditor() {
        super();
    }

    public void initialized() {
        final JTextField editor = getEditor();
        //editor.setIgnoreEnterKey(true);
        delegate = new EditorDelegate(this) {
            public void setValue(Object value) {
                MyAbstractTextEditor.this.setValue(value);
            }

            public Object getValue() {
                return MyAbstractTextEditor.this.getValue();
            }
        };
        editor.addActionListener(delegate);
        editor.addKeyListener(delegate);
        initialize(getEditor());
    }

}
