// copyright 2001-2002 by The Mind Electric

package electric.xml;

import java.io.*;

/**
 * <tt>Fragment</tt>.
 *
 * @author <a href="http://www.themindelectric.com">The Mind Electric</a>
 */

public final class Fragment extends Parent implements org.w3c.dom.DocumentFragment
  {
  // ********** CONSTRUCTION ************************************************

  /**
   *
   */
  public Fragment()
    {
    }

  /**
   * Construct a copy of the specified fragment.
   * @param fragment The fragment to copy.
   */
  public Fragment( Fragment fragment )
    {
    super( fragment );
    }

  // ********** CLONING *****************************************************

  /**
   * Return a clone of this fragement.
   */
  public Object clone()
    {
    return new Fragment( this );
    }

  // ********** DOM *********************************************************

  /**
   * Return DOCUMENT_FRAGEMENT_NODE.
   */
  public short getNodeType()
    {
    return DOCUMENT_FRAGMENT_NODE;
    }

  /**
   * Return "#document-fragment".
   */
  public String getNodeName()
    {
    return "#document-fragment";
    }
  }